!  Post3D
!
!   DESCRIPTION
!   Phase shift and split step migration plus interpolation
!
!   USAGE
!     Ph3D_MP < in.H > out.H par=par.P apply_split_step=
!
!%

program Pre2D_new_ssf

  use sep
  use gendown3d_mod

  use Pre2D_new_ssf_types
  use Pre2D_new_ssf_mod

  implicit none


  interface 
     subroutine param_Pre2D_new_ssf(Pre2D_new_ssf_par)
       use Pre2D_new_ssf_types
       type (Pre2D_new_ssf_param_type) Pre2D_new_ssf_par
     end subroutine param_Pre2D_new_ssf
  end interface
 


  type (Pre2D_new_ssf_param_type) Pre2D_new_ssf_par
  logical adj,add
  logical datuming,prestack,wemva,python
  integer stat,getch
  external getch
  character(len=128) tag_data,tag_mod
  integer                          :: omp_get_num_threads

  type (gendown3d_param_type) gen_par

  call initpar()

  call from_par('python',python,.false.)
    if (python) then
! neede for python
    call set_no_putch()
! fix a problem with auxin and python paralelization
    call getch_add_string("head=/dev/null")
    call getch_add_string("noheader=y")
  end if

  call sep_begin_prog()

  call from_par('wemva',wemva,.false.)
  call from_par('datuming',datuming,.false.)
  call from_par('add',add,.false.)
  call from_par('adj',adj,.false.)

!  gen_par%first_adj=adj

  if(datuming) then
    tag_data='Down_data'
    tag_mod='Data'
  else
    if(wemva) then
      tag_data='Dimage'
      tag_mod='Dslow'
    else
      tag_data='Image'
      tag_mod='Data'
    end if
  end if

    call param_Pre2D_new_ssf(Pre2D_new_ssf_par)
    call init_Pre2D_new_ssf_par(Pre2D_new_ssf_par)
    call gendown3d_init(verb=.false.,init_down_oper=Pre2D_new_ssf_init)

!!$OMP PARALLEL
!!  write(0,*)'In Main: n_threads =',omp_get_num_threads()
!!$OMP END PARALLEL

   stat=gendown3d(adj,add,tag_mod,tag_data, &
                  Pre2D_new_ssf_down_oper,Pre2D_new_ssf_scatter_oper)
 
   call sep_end_prog()


  stop	
end program Pre2D_new_ssf
